Array.prototype.item = function(i) { return this[i]; };

function foreach(items, fun)
{
    for (var i = 0; i < items.length; i++) {
	fun(items.item(i));
    }
}

function all(items, pred)
{
    for (var i = 0; i < items.length; i++) {
	if (!pred(items.item(i))) {
	    return false;
	}
    }

    return true;
}

function add_hook(obj, hook, fun)
{
    if (!obj[hook]) {
	obj[hook] = fun;
    } else {
	var tmp = obj[hook];
	obj[hook] = function(){ tmp(); fun(); }
    }
}


var on_load = new Object();

on_load.TopPage =
    function() {
	function focus_id_entry() {
	    document.getElementsByName('id').item(0).focus();
	}

	function setup_checks(e) {
	   e.onclick = focus_id_entry;
	}

	var checks = document.getElementById('libraries')
			     .getElementsByTagName('input');

	foreach(checks, setup_checks)

	focus_id_entry();
    };



on_load.SearchPage =
    function() {
	function enable_if_any_queries()
	{
	    function value_is_empty(e) { return e.value == ''; }
	    function not_checked(e) { return !e.checked; }

	    submit.disabled = all(queries, value_is_empty)
	                          || all(checks, not_checked);
	}

	function reset_state() {
	    submit.disabled = true;
	    last_input.focus();
	}

	function setup_textinput(e) {
	    e.onfocus = function(){ last_input = e; };
	    e.onkeyup = enable_if_any_queries;
	}

	function setup_checkbox(e) {
	    e.onclick = function() {
		            last_input.focus();
		            enable_if_any_queries();
			};
	}

	var last_input = document.getElementsByName('title').item(0);
	var submit = document.getElementsByName('submit').item(0);
	var checks = document.getElementById('libraries')
			     .getElementsByTagName('input');
	var queries = document.getElementById('query')
			       .getElementsByTagName('input')

	foreach(queries, setup_textinput);

	foreach(checks, setup_checkbox);

	document.getElementById('reset').onclick = reset_state;

	reset_state();
    };



on_load.MoveConfirmationPage =
on_load.RemovalConfirmationPage =
    function() {
	document.getElementById('do_it').focus();
    };



on_load.EditPage =
    function() {
	document.getElementsByName('title').item(0).focus();
    };


add_hook(window, 'onload',
         function() {
	     f = on_load[document.body.id]
	     if (f) f();
	 })
