#!/usr/local/bin/ruby

require 'cgi'

require 'cocoron'

require 'page'

$KCODE = 'utf-8'

#
# main routine
#
#   cmd=commit;lib=library_name;title= ...
#   cmd=write_note;lib=library_name;id=id;note=str
#   cmd=remove;id=id;lib=library
#

def update_and_create_page(cgi)
   unless cgi.request_method =~ /post/oi then
      TopPage.new(cgi)
   else
      case cgi.get_param('cmd')
      when 'commit' then
	 lib = load_library(cgi.get_param('lib'), :w)
         id_str = cgi.get_param('id').untaint
	 id = Cocoron::BookID.parse(id_str)
         title = cgi.get_param('title')
         authors = cgi.get_param('authors')\
                      .to_a.collect{|s| s.strip }.reject{|s| s.empty? }
         publisher = cgi.get_param('publisher')
         edition = cgi.get_param('edition')
         price = cgi.get_param('price')
         release_date = cgi.get_param('release_date')
         image_url_small = cgi.get_param('image_url_small')
         image_url_medium = cgi.get_param('image_url_medium')
         image_url_large = cgi.get_param('image_url_large')

         book = lib[id.code] || Cocoron::Book.new(id)

         book.title = title
         book.authors = authors
         book.publisher = publisher
         book.edition = edition
         book.price = price
         book.release_date = release_date
         book.image_url_small = image_url_small
         book.image_url_medium = image_url_medium
         book.image_url_large = image_url_large

         lib[book.id.code] = book
         ViewPage.new(cgi, lib, book)
      when 'remove' then
         id_str = cgi.get_param('id').untaint
	 lib = load_library(cgi.get_param('lib'), :w)

         lib.delete(id_str)

         TopPage.new(cgi)
      when 'move' then
	 from_lib = load_library(cgi.get_param('from'), :w)
	 to_lib = load_library(cgi.get_param('to'), :w)
         id_str = cgi.get_param('id').untaint

	 book = to_lib[id_str] = from_lib[id_str]
	 from_lib.delete(id_str)

	 ListPage.contains(book, to_lib, cgi)
      when 'write_note' then
	 lib = load_library(cgi.get_param('lib'), :w)
         id_str = cgi.get_param('id').untaint
         note = CGI.unescapeHTML(cgi.get_param('note'))

         book = lib[id_str]
         book.write_note(note)
         lib[id_str] = book

         ListPage.contains(book, lib, cgi)
      else
	 TopPage.new(cgi)
      end
   end
rescue IndexError then               # for CGI#params.fetch
   TopPage.new(cgi)
end


c = CGI.new

begin
   update_and_create_page(c).show
rescue Exception => err then
   ErrorPage.new(c, [err.message, *err.backtrace].join("\n")).show
end
