require 'cocoron/book-id'

module Cocoron
   class Book
      attr_reader :id, :mtime, :ctime

      attr_accessor :title, :authors, :publisher, :edition, :price,
	  :release_date, :image_url_small, :image_url_medium,
	  :image_url_large, :note

      def initialize(id, info = Hash.new)
      	 @id = id
	 @title = info[:title] || ''
	 @authors = info[:authors] || []
	 @publisher = info[:publisher] || ''
	 @edition = info[:edition] || ''
	 @price = info[:price] || ''
	 @release_date = info[:release_date] || ''
	 @image_url_small = info[:image_url_small] || ''
	 @image_url_medium = info[:image_url_medium] || ''
	 @image_url_large = info[:image_url_large] || ''

	 @note = ''
	 @mtime = @ctime = Time.now
      end

      def write_note(str)
	 modified
	 @note = str
      end

      def hash
	 self.id.hash
      end

      def eql?(other)
	 other.is_a?(self.class) && self.id == other.id
      end

      alias :== :eql?

   private
      def modified
	 @mtime = Time.now
      end
   end
end
