#/usr/local/bin/ruby
require 'open-uri'
require 'cocoron'

GIF_MAGICNUM = 'GIF8'

def gif?(str)
   str[0, (GIF_MAGICNUM.length)] == GIF_MAGICNUM
end

libpath, outdir, = ARGV

Cocoron::Library.new(libpath).each do |id, book|
   $stderr.puts id

   %w(small medium large).each do |size|
      u = URI.parse(book.send("image_url_#{size}"))
      opath = File.join(outdir, File.basename(u.path))

      unless File.exist?(opath) then
	 open(u) do |img|
	    unless u.empty? then
               cont = img.read

               unless gif?(cont) then
                  open(opath, 'w'){|out| out.write(cont) }
               end
	    else
	       $stderr.puts "skip %s.image_%s" % [id, size]
	    end
	 end

         sleep rand + 1
      end
   end
end
